<?php

	// Load gateway setings
	require_once(dirname(dirname(dirname(dirname(__FILE__)))) . '/idealcheckout/includes/library.php');

	class idealcheckoutafterpay
	{
		var $code, $title, $description, $enabled, $form_action_url;

		// class constructor
		function idealcheckoutafterpay()
		{
			$this->icon = DIR_WS_ICONS . 'idealcheckoutafterpay.png';
			$this->code = 'idealcheckoutafterpay';
			$this->title = MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_TEXT_TITLE;
			$this->description = MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_TEXT_DESCRIPTION;
			$this->sort_order = MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_SORT_ORDER;
			// $this->enabled = MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_STATUS;

			// Minimum amount - start
			if(in_array(strtolower(MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_STATUS), array(1, '1', 'true', 'y', 'yes', 'ja')))
			{
				$cart_total = $_SESSION['cart']->total;

				if($cart_total >= 1.00)
				{
					$this->enabled = true;
				}
				else
				{
					$this->enabled = false;
				}
			}
			else
			{
				$this->enabled = false;
			}

			$this->email_footer = '';
		}

		// class methods
		function javascript_validation()
		{
			return true;
		}

		function selection()
		{
			return array('id' => $this->code, 'module' => $this->title);
		}

		function pre_confirmation_check()
		{
			return false;
		}

		function confirmation()
		{
			return array('title' => $this->description);
		}

		function process_button()
		{
			return '';
		}

		function before_process()
		{
			return false;
		}

		function after_process()
		{
			global $HTTP_POST_VARS, $customer_id, $order, $currencies;

			$sql = "SELECT `orders_id` AS `id` FROM `" . TABLE_ORDERS . "` WHERE (`customers_id` = '" . (int) $customer_id . "') ORDER BY `id` DESC LIMIT 1;";
			$oRecordset = tep_db_query($sql);

			if(tep_db_num_rows($oRecordset) && ($aRecord = tep_db_fetch_array($oRecordset)))
			{
				$aDatabaseSettings = idealcheckout_getDatabaseSettings();

				$sStoreCode = idealcheckout_getStoreCode();
				$sGatewayCode = 'afterpay';
				$sLanguageCode = 'nl'; // nl, de, en
				$sCountryCode = '';
				$sCurrencyCode = 'EUR';


				// Add transaction record to database
				$sOrderId = $aRecord['id'];
				$sOrderCode = idealcheckout_getRandomCode(32);
				$aOrderParams = array();
				$sTransactionId = idealcheckout_getRandomCode(32);
				$sTransactionCode = idealcheckout_getRandomCode(32);
				$fTransactionAmount = number_format(str_replace(',', '.', ($order->info['total'] * $order->info['currency_value'])), 2, '.', '');
				$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));
				$sTransactionPaymentUrl = tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL');
				$sTransactionSuccessUrl = tep_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL');
				$sTransactionPendingUrl = tep_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL');
				$sTransactionFailureUrl = tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL');





				$aOrderParams['customer'] = array();

				// Shipment data
				list($sStreetName, $sStreetNumber, $sExtension) = idealcheckout_mb_splitAddress($order->delivery['street_address']);

				$aOrderParams['customer']['shipment_company'] = $order->delivery['company'];
				$aOrderParams['customer']['shipment_name'] = $order->delivery['firstname'] . ' ' . $order->delivery['lastname'];
				$aOrderParams['customer']['shipment_first_name'] = $order->delivery['firstname'];
				$aOrderParams['customer']['shipment_last_name'] = $order->delivery['lastname'];
				$aOrderParams['customer']['shipment_gender'] = '';
				$aOrderParams['customer']['shipment_date_of_birth'] = '';
				$aOrderParams['customer']['shipment_phone'] = $order->customer['telephone'];
				$aOrderParams['customer']['shipment_email'] = $order->customer['email_address'];
				$aOrderParams['customer']['shipment_address'] = $order->delivery['street_address'];
				$aOrderParams['customer']['shipment_street_name'] = $sStreetName;
				$aOrderParams['customer']['shipment_street_number'] = $sStreetNumber;
				$aOrderParams['customer']['shipment_street_number_extension'] = $sExtension;
				$aOrderParams['customer']['shipment_zipcode'] = $order->delivery['postcode'];
				$aOrderParams['customer']['shipment_city'] = $order->delivery['city'];
				$aOrderParams['customer']['shipment_country_code'] = $order->delivery['country']['iso_code_2'];
				$aOrderParams['customer']['shipment_country_name'] = ((strcasecmp($order->delivery['country']['iso_code_2'], 'BE') === 0) ? 'Belgie' : 'Nederland');


				// Payment data
				list($sStreetName, $sStreetNumber, $sExtension) = idealcheckout_mb_splitAddress($order->billing['street_address']);

				$aOrderParams['customer']['payment_company'] = $order->billing['company'];
				$aOrderParams['customer']['payment_name'] = $order->billing['firstname'] . ' ' . $order->billing['lastname'];
				$aOrderParams['customer']['payment_first_name'] = $order->billing['firstname'];
				$aOrderParams['customer']['payment_last_name'] = $order->billing['lastname'];
				$aOrderParams['customer']['payment_gender'] = '';
				$aOrderParams['customer']['payment_date_of_birth'] = '';
				$aOrderParams['customer']['payment_phone'] = $order->customer['telephone'];
				$aOrderParams['customer']['payment_email'] = $order->customer['email_address'];
				$aOrderParams['customer']['payment_address'] = $order->billing['street_address'];
				$aOrderParams['customer']['payment_street_name'] = $sStreetName;
				$aOrderParams['customer']['payment_street_number'] = $sStreetNumber;
				$aOrderParams['customer']['payment_street_number_extension'] = $sExtension;
				$aOrderParams['customer']['payment_zipcode'] = $order->billing['postcode'];
				$aOrderParams['customer']['payment_city'] = $order->billing['city'];
				$aOrderParams['customer']['payment_country_code'] = $order->billing['country']['iso_code_2'];
				$aOrderParams['customer']['payment_country_name'] = ((strcasecmp($order->billing['country']['iso_code_2'], 'BE') === 0) ? 'Belgie' : 'Nederland');


				// Products
				$aOrderParams['products'] = array();

				$fTotalAmountIncl = 0.00;
				$fTotalAmountExcl = 0.00;

				foreach($order->products as $k => $aProduct)
				{
					$fPriceExcl = round($aProduct['final_price'] * $order->info['currency_value'], 2);
					$fPriceVat = round($fPriceExcl * ($aProduct['tax'] / 100), 2);
					$fPriceIncl = round($fPriceExcl + $fPriceVat, 2);

					$fVatPercentage = $aProduct['tax'];
					$fQuantity = $aProduct['qty'];

					$fTotalAmountIncl += ($fPriceIncl * $fQuantity);
					$fTotalAmountExcl += ($fPriceExcl * $fQuantity);

					$aOrderParams['products'][] = array('code' => $aProduct['id'], 'description' => $aProduct['name'], 'quantity' => $fQuantity, 'price_incl' => $fPriceIncl, 'price_excl' => $fPriceExcl, 'vat' => $fVatPercentage);
				}



				// Payment costs?
				$fPaymentExcl = round(empty($order->info['payment_cost']) ? 0 : ($order->info['payment_cost'] * $order->info['currency_value']), 2);
				$fPaymentTaxPercentage = round(empty($order->info['payment_tax']) ? 0 : $order->info['payment_tax'], 2);
				$fPaymentTax = round($fPaymentExcl * ($fPaymentTaxPercentage / 100), 2);
				$fPaymentIncl = round($fPaymentExcl + $fPaymentTax, 2);

				if(!empty($fPaymentIncl))
				{
					$fTotalAmountIncl += $fPaymentIncl;
					$fTotalAmountExcl += $fPaymentExcl;

					$aOrderParams['products'][] = array('code' => 'PAYMENT', 'description' => 'Betaalkosten', 'quantity' => '1', 'price_incl' => $fPaymentIncl, 'price_excl' => $fPaymentExcl, 'vat' => $fPaymentTaxPercentage);
				}



				// Shipment costs?
				$fShipmentExcl = round(empty($order->info['shipping_cost']) ? 0 : ($order->info['shipping_cost'] * $order->info['currency_value']), 2);
				$fShipmentTaxPercentage = round(empty($order->info['shipping_tax']) ? 0 : $order->info['shipping_tax'], 2);
				$fShipmentTax = round($fShipmentExcl * ($fShipmentTaxPercentage / 100), 2);
				$fShipmentIncl = round($fShipmentExcl + $fShipmentTax, 2);

				if(!empty($fShipmentIncl))
				{
					$fTotalAmountIncl += $fShipmentIncl;
					$fTotalAmountExcl += $fShipmentExcl;

					$aOrderParams['products'][] = array('code' => 'SHIPPING', 'description' => 'Verzendkosten', 'quantity' => '1', 'price_incl' => $fShipmentIncl, 'price_excl' => $fShipmentExcl, 'vat' => $fShipmentTaxPercentage);
				}

				$fCorrection = round($fTransactionAmount - $fTotalAmountIncl, 2);

				if($fCorrection != 0.00)
				{
					$aOrderParams['products'][] = array('code' => 'CORRECTION', 'description' => 'Correctie', 'quantity' => '1', 'price_incl' => $fCorrection, 'price_excl' => $fCorrection, 'vat' => 0);
				}


				// Insert into #_transactions
				$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";

				tep_db_query($sql);





				// Cleanup cart & sessions
				global $cart;
				$cart->reset(true);

				tep_session_unregister('sendto');
				tep_session_unregister('billto');
				tep_session_unregister('shipping');
				tep_session_unregister('payment');
				tep_session_unregister('comments');





				// Redirect to checkout
				tep_redirect(idealcheckout_getRootUrl() . 'idealcheckout/setup.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode);
			}

			return false;
		}

		function output_error()
		{
			debug_print_backtrace();
			exit;

			return false;
		}


		function check()
		{
			if(!isset($this->check))
			{
				$check_query = tep_db_query("SELECT `configuration_value` FROM `" . TABLE_CONFIGURATION . "` WHERE `configuration_key` = 'MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_STATUS' LIMIT 1;");
				$this->check = tep_db_num_rows($check_query);
			}

			return $this->check;
		}

		function install()
		{
			tep_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_title`, `configuration_key`, `configuration_value`, `configuration_description`, `configuration_group_id`, `sort_order`, `date_added`) values ('Allow AfterPay Payments', 'MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_STATUS', '1', 'Do you want to accept iDEAL payments?', '6', '100', now())");
			tep_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_title`, `configuration_key`, `configuration_value`, `configuration_description`, `configuration_group_id`, `sort_order`, `date_added`) values ('Sort order of display.', 'MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '101', now())");
			tep_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_title`, `configuration_key`, `configuration_value`, `configuration_description`, `configuration_group_id`, `sort_order`, `date_added`) values ('AfterPay Client Language', 'MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_LANGUAGE', 'nl', 'Client language', '6', '102', now())");
		}

		function remove()
		{
			tep_db_query("DELETE FROM `" . TABLE_CONFIGURATION . "` WHERE `configuration_key` IN ('" . implode("', '", $this->keys()) . "')");
		}

		function keys()
		{
			return array('MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_STATUS', 'MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_SORT_ORDER', 'MODULE_PAYMENT_IDEALCHECKOUTAFTERPAY_LANGUAGE');
		}
	}

?>